#include <stdio.h>
#include <sys/elf32.h>
#include <sys/elf64.h>

void print_elf32(FILE* f){
 Elf32_Ehdr h;
 Elf32_Shdr section;
 Elf32_Phdr progheader;
 Elf32_Sym symbol;

 int i;

 fread(&h, sizeof h, 1, f);
 
 printf(" File type.  = %i\n", h.e_type);
 printf(" Machine architecture.  = %i\n", h.e_machine);
 printf(" ELF format version.  = %i\n", h.e_version);
 printf(" Entry point.  = 0x%llX\n", h.e_entry);
 printf(" Program header file offset.  = 0x%llX\n", h.e_phoff);
 printf(" Section header file offset.  = 0x%llX\n", h.e_shoff);
 printf(" Architecture-specific flags.  = %i\n", h.e_flags);
 printf(" Size of ELF header in bytes.  = %i\n", h.e_ehsize);
 printf(" Size of program header entry.  = %i\n", h.e_phentsize);
 printf(" Number of program header entries.  = %i\n", h.e_phnum);
 printf(" Size of section header entry.  = %i\n", h.e_shentsize);
 printf(" Number of section header entries.  = %i\n", h.e_shnum);
 printf(" Section name strings section.  = %i\n", h.e_shstrndx); 
 printf("\n\n");

 fseek(f, h.e_phoff, 0);
 for(i=1; i<=h.e_phnum; i++){
  fread(&progheader, h.e_phentsize, 1, f);
  printf("Program header number %i\n", i);
  printf(" Entry type.  = %i\n", progheader.p_type);
  printf(" File offset of contents.  = %lli\n", progheader.p_offset);
  printf(" Virtual address in memory image.  = 0x%llX\n", progheader.p_vaddr);
  printf(" Physical address (not used).  = 0x%llX\n", progheader.p_paddr);
  printf(" Size of contents in file.  = %lli\n", progheader.p_filesz);
  printf(" Size of contents in memory.  = %lli\n", progheader.p_memsz);
  printf(" Access permission flags.  = %lli\n", progheader.p_flags);
  printf(" Alignment in memory and file.  = %lli\n", progheader.p_align); 
 }
 printf("\n");

 fseek(f, h.e_shoff, 0);
 for(i=1; i<=h.e_shnum; i++){
  fread(&section, h.e_shentsize, 1, f);
  printf("Section number %i\n", i);
  printf(" Section name (index into the section header string table).  = %i\n", section.sh_name);
  printf(" Section type.  = %i\n", section.sh_type);
  printf(" Section flags.  = %lli\n", section.sh_flags);
  printf(" Address in memory image.  = 0x%llX\n", section.sh_addr);
  printf(" Offset in file.  = 0x%llX\n", section.sh_offset);
  printf(" Size in bytes.  = %lli\n", section.sh_size);
  printf(" Index of a related section.  = %i\n", section.sh_link);
  printf(" Depends on section type.  = %i\n", section.sh_info);
  printf(" Alignment in bytes.  = %lli\n", section.sh_addralign);
  printf(" Size of each entry in section.  = %lli\n", section.sh_entsize);
 }
 printf("\n");
}

void print_elf64(FILE* f){
 Elf64_Ehdr h;
 Elf64_Shdr section;
 Elf64_Phdr progheader;
 Elf64_Sym symbol;

 int i;

 fread(&h, sizeof h, 1, f);
 
 printf(" File type.  = %i\n", h.e_type);
 printf(" Machine architecture.  = %i\n", h.e_machine);
 printf(" ELF format version.  = %i\n", h.e_version);
 printf(" Entry point.  = 0x%X\n", h.e_entry);
 printf(" Program header file offset.  = 0x%X\n", h.e_phoff);
 printf(" Section header file offset.  = 0x%X\n", h.e_shoff);
 printf(" Architecture-specific flags.  = %i\n", h.e_flags);
 printf(" Size of ELF header in bytes.  = %i\n", h.e_ehsize);
 printf(" Size of program header entry.  = %i\n", h.e_phentsize);
 printf(" Number of program header entries.  = %i\n", h.e_phnum);
 printf(" Size of section header entry.  = %i\n", h.e_shentsize);
 printf(" Number of section header entries.  = %i\n", h.e_shnum);
 printf(" Section name strings section.  = %i\n", h.e_shstrndx); 
 printf("\n\n");

 fseek(f, h.e_phoff, 0);
 for(i=1; i<=h.e_phnum; i++){
  fread(&progheader, h.e_phentsize, 1, f);
  printf("Program header number %i\n", i);
  printf(" Entry type.  = %i\n", progheader.p_type);
  printf(" File offset of contents.  = %i\n", progheader.p_offset);
  printf(" Virtual address in memory image.  = 0x%X\n", progheader.p_vaddr);
  printf(" Physical address (not used).  = 0x%X\n", progheader.p_paddr);
  printf(" Size of contents in file.  = %i\n", progheader.p_filesz);
  printf(" Size of contents in memory.  = %i\n", progheader.p_memsz);
  printf(" Access permission flags.  = %i\n", progheader.p_flags);
  printf(" Alignment in memory and file.  = %i\n", progheader.p_align); 
 }
 printf("\n");

 fseek(f, h.e_shoff, 0);
 for(i=1; i<=h.e_shnum; i++){
  fread(&section, h.e_shentsize, 1, f);
  printf("Section number %i\n", i);
  printf(" Section name (index into the section header string table).  = %i\n", section.sh_name);
  printf(" Section type.  = %i\n", section.sh_type);
  printf(" Section flags.  = %i\n", section.sh_flags);
  printf(" Address in memory image.  = 0x%X\n", section.sh_addr);
  printf(" Offset in file.  = 0x%X\n", section.sh_offset);
  printf(" Size in bytes.  = %i\n", section.sh_size);
  printf(" Index of a related section.  = %i\n", section.sh_link);
  printf(" Depends on section type.  = %i\n", section.sh_info);
  printf(" Alignment in bytes.  = %i\n", section.sh_addralign);
  printf(" Size of each entry in section.  = %i\n", section.sh_entsize);
 }
 printf("\n");
}

main(int ac, char** av)
{
FILE* f;
struct {
  unsigned char ei_magic[4];
  unsigned char ei_class;
  unsigned char ei_data;
  unsigned char ei_version;
  unsigned char ei_pad[9];
} e_ident;

if(ac!=2) fprintf(stderr, "use %s with path on elf32 file\n", av[0]), exit(1);
f = fopen(av[1], "rb");
fread(&e_ident, sizeof e_ident, 1, f);
if(memcmp(&e_ident, "ELF", 4)!=0) fprintf(stderr, "This is not elf!\n"), exit(1);
if(e_ident.ei_class==1) printf("This is elf32\n"); 
else if(e_ident.ei_class==2) printf("This is elf64\n"); 
else fprintf(stderr, "This class elf not support!\n"), exit(1);

printf("byte-ordering: %s\n", e_ident.ei_data==1?"LSB":"MSB");
if(e_ident.ei_version!=1) fprintf(stderr, "elf version is %i. This util support first version only.\n", e_ident.ei_version), exit(1);
printf("\n\n");

fseek(f, 0, 0);
if(e_ident.ei_class == 1) print_elf32(f); else print_elf64(f);
fclose(f);
return 0;
}
